; Dialog: CreateWindowEx (without WS_EX_CONTROLPARENT) + IsDialogMessage.  Enter, Esc, Tab.
; Edit controls havn't ES_MULTILINE.

.386
.model  flat,stdcall
option  casemap:none

include			\masm32\include\windows.inc
include			\masm32\include\user32.inc
include			\masm32\include\kernel32.inc
includelib	\masm32\lib\user32.lib
includelib	\masm32\lib\kernel32.lib

.data
AppClass				db "TestApp",0
ButtonClass			db "Button",0
EditClass				db "Edit",0

.data?
hInstance				HINSTANCE	?
hwnd3						HWND ?
hwnd4						HWND ?
buf							db 256 dup(?)

.code

WndProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	.if uMsg==WM_DESTROY
		invoke PostQuitMessage,0

	.elseif	uMsg==WM_CREATE
		invoke CreateWindowEx,0,offset ButtonClass,offset ButtonClass,WS_CHILD or WS_VISIBLE or WS_TABSTOP or BS_PUSHBUTTON,10,10,200,40,hWnd,3001,hInstance,0
		invoke CreateWindowEx,0,offset ButtonClass,offset EditClass,WS_CHILD or WS_VISIBLE or WS_TABSTOP or BS_DEFPUSHBUTTON,10,60,200,40,hWnd,3002,hInstance,0
		invoke CreateWindowEx,WS_EX_CLIENTEDGE,offset EditClass,0,WS_CHILD or WS_VISIBLE or WS_TABSTOP or ES_LEFT,10,110,200,40,hWnd,3003,hInstance,0
		mov hwnd3,eax
		invoke SetFocus,eax
		invoke CreateWindowEx,WS_EX_CLIENTEDGE,offset EditClass,0,WS_CHILD or WS_VISIBLE or WS_TABSTOP or ES_LEFT,10,160,200,40,hWnd,3004,hInstance,0
		mov hwnd4,eax

	.elseif	uMsg==WM_COMMAND && wParam==IDCANCEL	; IDCANCEL=2
		invoke DestroyWindow,hWnd

	.elseif	uMsg==WM_COMMAND && wParam==IDOK		; IDOK=1
		invoke GetFocus
		.if eax==hwnd3 || eax==hwnd4
			invoke SendMessage,eax,WM_GETTEXT,255,offset buf
			invoke SendMessage,hWnd,WM_SETTEXT,0,offset buf
		.else
			invoke SendMessage,hWnd,WM_SETTEXT,0,offset AppClass
		.endif

	.elseif	uMsg==WM_COMMAND && wParam==3001
		invoke SendMessage,hWnd,WM_SETTEXT,0,offset ButtonClass

	.elseif	uMsg==WM_COMMAND && wParam==3002
		invoke SendMessage,hWnd,WM_SETTEXT,0,offset EditClass

	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret

	.endif
	xor eax,eax
	ret
WndProc endp


WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
   local wc:WNDCLASSEX
   local msg:MSG
   local hwnd:HWND

	mov wc.cbSize,sizeof wc
	mov wc.style,0
	mov wc.lpfnWndProc,offset WndProc
	mov wc.cbClsExtra,0
	mov wc.cbWndExtra,0
	mov eax,hInst
	mov wc.hInstance,eax
	mov wc.hbrBackground,COLOR_3DFACE+1
	mov wc.lpszMenuName,0
	mov wc.lpszClassName,offset AppClass
	invoke LoadIcon,0,IDI_EXCLAMATION
	mov wc.hIcon,eax
	mov wc.hIconSm,eax
	invoke LoadCursor,0,IDC_ARROW
	mov wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke CreateWindowEx,0,offset AppClass,offset AppClass,WS_POPUP or WS_SYSMENU or WS_CAPTION,300,10,300,300,0,0,hInstance,0
	mov hwnd,eax
	invoke ShowWindow,eax,CmdShow
	invoke UpdateWindow,hwnd

	.while TRUE
		invoke GetMessage, addr msg,NULL,0,0
		.break .if (!eax)
		invoke IsDialogMessage,hwnd,addr msg
		.if eax==FALSE
			invoke TranslateMessage, addr msg
			invoke DispatchMessage, addr msg
		.endif
	.endw

	mov eax,msg.wParam
	ret
WinMain endp


start:
invoke GetModuleHandle,0
mov hInstance,eax
invoke WinMain,eax,0,0,SW_SHOWDEFAULT
invoke ExitProcess,eax
end start
